//
//  service .exe
//
//	 2001/11/6  by takapyu
//
#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include <commctrl.h>

#include "resource.h"

#ifndef ICON_SMALL
#define ICON_SMALL	0
#endif
#ifndef ICON_BIG
#define ICON_BIG	1
#endif

#define ERROR_PARAMETER			1
#define ERROR_NO_INSTALL		2
#define ERROR_INSTALL			3
#define ERROR_START				4

#define END_CLOSE				0
#define END_SYSCOMMAND			1
#define END_SYS_AND_CLOSE		2
#define END_CTRL_BREAK			3

#define	PRIORITY_REALTIME		0
#define	PRIORITY_HIGH			1
#define	PRIORITY_ABOVE_NORMAL	2
#define	PRIORITY_NORMAL			3
#define	PRIORITY_BELOW_NORMAL	4
#define	PRIORITY_LOW			5

// 2010/6/10 Vista/7  WM_DROPFILES 󂯂
typedef BOOL (WINAPI *funcChangeWindowMessageFilter)(UINT, DWORD);
#define MSGFLT_ADD				1
#define MSGFLT_REMOVE			2

#if _MSC_VER < 1400
typedef LANGID (WINAPI *funcGetUserDefaultUILanguage)();
#ifndef ABOVE_NORMAL_PRIORITY_CLASS
#define	ABOVE_NORMAL_PRIORITY_CLASS	0x00008000
#endif
#ifndef BELOW_NORMAL_PRIORITY_CLASS
#define	BELOW_NORMAL_PRIORITY_CLASS	0x00004000
#endif
#endif

// wb_Ƃ
const TCHAR *HEADER = _T("sexe");
const TCHAR *ERROR_HEADER = _T("sexe error");
const TCHAR *MUTEX_STRING = _T("$$sexe$$%s$$");
const TCHAR *WINDOW_TITLE = _T("sexe");

#ifdef WIN64
const TCHAR *INI_FILE_NAME = _T("sexe64.ini");
#else
const TCHAR *INI_FILE_NAME = _T("sexe.ini");
#endif

// .ini ̃L[
const TCHAR *KEY_EXE = _T("exe");
const TCHAR *KEY_OPTION = _T("option");
const TCHAR *KEY_NAME = _T("name");
const TCHAR *KEY_DESCRIPTION = _T("description");
const TCHAR *KEY_END = _T("end");
// 2004/8/9
const TCHAR *KEY_AUTO = _T("auto");
const TCHAR *KEY_DESKTOP = _T("desktop");
// 2009/3/26
const TCHAR *KEY_RETRY = _T("retry");
// 2009/8/26
const TCHAR *KEY_ENCODE = _T("encode");
// 2021/5/17
const TCHAR *KEY_PRIORITY = _T("priority");

// ʓ|Ȃ̂ŃO[oϐg܂Ă܂B
SERVICE_STATUS_HANDLE service_handle;
BOOL service_flag;					// running serivce
BOOL service_install_flag;			// install service
BOOL service_stop_flag;				// stop service
BOOL nt_flag;						// runnning Windows NT ?

TCHAR module_name[MAX_PATH];		// sexe.exe ̃tpX
TCHAR execute_path[MAX_PATH];		// sexe.exe ̃tH_
TCHAR ini_name[MAX_PATH];			// sexe.ini ̃tpX
TCHAR exe_name[MAX_PATH];			// T[rXƂē삳vÕtpX
TCHAR option_name[MAX_PATH];		// NIvV
TCHAR service_name[MAX_PATH];		// T[rX
TCHAR description_name[MAX_PATH];	// 2009/3/26 T[rX
TCHAR language_name[MAX_PATH];
int end_pattern;					// I@
int auto_flag;						// 2004/8/9 N
int desktop_flag;					// 2004/8/9 fXNgbvƂ̑Θb
int retry_flag;						// 2009/3/26 ċN
int shutdown_flag;					// 2009/3/26 Shutdown
int priority_flag;					// 2021/5/17 Dx
BOOL install_flag;					// 2011/4/28 CXg[
BOOL uninstall_flag;				// 2011/4/28 ACXg[
BOOL read_ini_flag;					// 2011/4/28 CXg[ ini t@CQ
BOOL start_flag;					// 2011/4/28 CXg[̂܂܃T[rXJn
BOOL no_error_flag;					// 2011/5/31 G[bZ[W\
BOOL question_flag;					// 2011/5/31 CXg[/ACXg[₢킹
BOOL ok_flag;						// 2011/5/31 IbZ[W\
BOOL language_flag;	
HANDLE mutex;						// dNh~p Mutex
DWORD process_id;					// NvÕvZX ID
HINSTANCE h_instance;				// hInstance
HINSTANCE h_icon_instance;			// hInstance

// ֐`
BOOL APIENTRY MainFunc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
BOOL send_status_to_scm(int state, int exit_code, int progress);
void service_control_handler(int control);
void service_main(void);
BOOL check_already(void);
BOOL remove_service(void);
int install_service(void);
BOOL restart_service(void);
BOOL check_execute_service(void);
void start_service(void);
void extract_directory(TCHAR *path);
TCHAR *extract_ext(TCHAR *path);
void get_inifile(void);
void set_inifile(void);

//
//	Xy[Xу^u΂
//	in: pt .. |C^
//	out: Xy[Xу^u΂̃|C^
//
TCHAR *space_skip(TCHAR *pt)
{
	while(*pt != _T(' ') && *pt != _T('\t') && *pt != _T('\0')) {
		pt++;
	}
	return pt;
}

//
//	p[^obt@ɃRs[
//	Xy[X͏I܂ŃRs[邪A
//	"" ň͂ꂽXy[X͖
//	in: dst .. Rs[obt@
//	    src .. Rs[obt@
//	    size .. obt@TCY
//	out: Rs[Ĩ|C^
//
TCHAR *copy_param(TCHAR *dst, TCHAR *src, int size)
{
	BOOL flag = FALSE;

	if(*src == _T('=')) {
		src++;
	}
	if(*src == _T('"')) {
		flag = TRUE;
		src++;
	}
	while(size > 1 && *src != _T('\0')) {
		*dst = *src;
		if(flag) {
			if(*src == _T('\\') && *(src + 1) == _T('"')) {
				src++;
				*dst = *src;
			} else if(*src == _T('"')) {
				*dst = _T('\0');
				return space_skip(src + 1);
			}
		} else if(!flag && (*src == _T(' ') || *src == _T('\t'))) {
			*dst = _T('\0');
			return space_skip(src);
		}
		src++;
		dst++;
		size--;
	}
	*dst = _T('\0');
	return (TCHAR *)src;
}

//
//	\[X當ǂݍŃbZ[W{bNX\
//	in: wnd .. I[i[EChEnh
//	    id  .. \[X ID
//	    param .. p[^(NULL Ŗ)
//	    caption .. ^Cg
//	    type .. bZ[W{bNXX^C
//	out: MessageBox() ̕Ԓl
//
int MessageBoxResourceText(HWND wnd, unsigned int id, const TCHAR *param, const TCHAR *caption, int type)
{
	TCHAR text[MAX_PATH * 2];

	if(param != NULL) {
		TCHAR temp[MAX_PATH * 2];
		LoadString(h_instance, id, temp, MAX_PATH * 2);
		wsprintf(text, temp, param);
	} else {
		LoadString(h_instance, id, text, MAX_PATH * 2);
	}
	return MessageBox(wnd, text, caption, type);
}

//
//	R}hCp[^͏
//	in: pt .. R}hCp[^
//
void analyze_args(TCHAR *pt)
{
	TCHAR param[MAX_PATH];
	TCHAR name[MAX_PATH];
	TCHAR exe[MAX_PATH];
	TCHAR option[MAX_PATH];
	TCHAR description[MAX_PATH];
	int autof, desktop, retry, end, priority;
	int no;
	struct {
		TCHAR *name;
		int *flag;
		TCHAR *dst;
	} list[] = {
		{ _T("install"), &install_flag, NULL },
		{ _T("uninstall"), &uninstall_flag, NULL },
		{ _T("ini"), &read_ini_flag, NULL },
		{ _T("name"), NULL, name },
		{ _T("exe"), NULL, exe },
		{ _T("option"), NULL, option },
		{ _T("description"), NULL, description },
		{ _T("desktop"), &desktop, NULL },
		{ _T("auto"), &autof, NULL },
		{ _T("start"), &start_flag, NULL },
		{ _T("no_error"), &no_error_flag, NULL },
		{ _T("ok"), &ok_flag, NULL },
		{ _T("question"), &question_flag, NULL },
		{ _T("retry"), &retry, NULL },
		{ _T("end"), &end, NULL },
		{ _T("priority"), &priority, NULL },
		{ NULL, NULL, NULL }
	};

	name[0] = _T('\0');
	exe[0] = _T('\0');
	option[0] = _T('\0');
	description[0] = _T('\0');
	desktop = FALSE;
	autof = FALSE;
	retry = FALSE;
	end = END_SYS_AND_CLOSE;
	priority = PRIORITY_NORMAL;
	while(*pt != _T('\0')) {
		if(*pt== '/' || *pt == '-') {
			pt++;
			for(no = 0 ; list[no].name != NULL ; no++) {
				if(!_tcsnicmp(pt, list[no].name, _tcslen(list[no].name))) {
					pt += _tcslen(list[no].name);
					if(list[no].flag != NULL) {
						if(!_tcsnicmp(list[no].name, _T("end"), _tcslen(list[no].name))) {
							copy_param(param, pt, MAX_PATH);
							if(!_tcsicmp(param, _T("close"))) {
								*list[no].flag = END_CLOSE;
							} else if(!_tcsicmp(param, _T("syscommand"))) {
								*list[no].flag = END_SYSCOMMAND;
							} else if(!_tcsicmp(param, _T("sysandclose"))) {
								*list[no].flag = END_SYS_AND_CLOSE;
							} else if(!_tcsicmp(param, _T("ctrlbreak"))) {
								*list[no].flag = END_CTRL_BREAK;
							} else if(param[0] >= _T('0') && param[0] <= _T('3')) {
								*list[no].flag = param[0] - _T('0');
							}
						} else if(!_tcsnicmp(list[no].name, _T("priority"), _tcslen(list[no].name))) {
							copy_param(param, pt, MAX_PATH);
							if(!_tcsicmp(param, _T("realtime"))) {
								*list[no].flag = PRIORITY_REALTIME;
							} else if(!_tcsicmp(param, _T("high"))) {
								*list[no].flag = PRIORITY_HIGH;
							} else if(!_tcsicmp(param, _T("abovenormal"))) {
								*list[no].flag = PRIORITY_ABOVE_NORMAL;
							} else if(!_tcsicmp(param, _T("normal"))) {
								*list[no].flag = PRIORITY_NORMAL;
							} else if(!_tcsicmp(param, _T("belownormal"))) {
								*list[no].flag = PRIORITY_BELOW_NORMAL;
							} else if(!_tcsicmp(param, _T("low"))) {
								*list[no].flag = PRIORITY_LOW;
							}
						} else {
							*list[no].flag = TRUE;
						}
					}
					if(list[no].dst != NULL) {
						pt = copy_param(list[no].dst, pt, MAX_PATH);
					}
				}
			}
		} else {
			pt++;
		}
	}
	if(install_flag || uninstall_flag) {
		// CXg[܂̓ACXg[ꍇ
		if(read_ini_flag) {
			// ini t@Cݒlǂ
			get_inifile();
		} else {
			// p[^̒lgp
#if _MSC_VER >= 1400
			_tcscpy_s(service_name, MAX_PATH, name);
			_tcscpy_s(exe_name, MAX_PATH, exe);
			_tcscpy_s(option_name, MAX_PATH, option);
			_tcscpy_s(description_name, MAX_PATH, description);
#else
			_tcscpy(service_name, name);
			_tcscpy(exe_name, exe);
			_tcscpy(option_name, option);
			_tcscpy(description_name, description);
#endif
			auto_flag = autof;
			desktop_flag = desktop;
			retry_flag = retry;
			end_pattern = end;
			priority_flag = priority;
		}
	} else {
		// ʏN̏ꍇAini t@Cݒlǂ
		get_inifile();
	}
}

HINSTANCE get_language_instance(HINSTANCE inst, TCHAR *dir)
{
#if _MSC_VER < 1400
	funcGetUserDefaultUILanguage GetUserDefaultUILanguage;
	if(GetUserDefaultUILanguage = (funcGetUserDefaultUILanguage)GetProcAddress(LoadLibrary(_T("kernel32.dll")) ,"GetUserDefaultUILanguage")) {
#endif
		HMODULE h;
		TCHAR path[MAX_PATH];
		LCID id;
		id = GetUserDefaultUILanguage();
		GetLocaleInfo(id, LOCALE_SENGLANGUAGE, language_name, MAX_PATH);
#if _MSC_VER >= 1400
		_stprintf_s(path, MAX_PATH, _T("%s\\%s"), dir, language_name);
#else
		wsprintf(path, _T("%s\\%s"), dir, language_name);
#endif
		h = LoadLibrary(path);
		if(h != NULL) {
			inst = (HINSTANCE)h;
			language_flag = TRUE;
		}
#if _MSC_VER < 1400
	}
#endif
	return inst;
}

//
//	Windows C֐
//
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpszArgs, int nWinMode)
{
    MSG msg;
	HWND hMain;
	int err;

	// 
	install_flag = FALSE;
	uninstall_flag = FALSE;
	read_ini_flag = FALSE;
	start_flag = FALSE;
	no_error_flag = FALSE;
	question_flag = FALSE;
	ok_flag = FALSE;

	// sfBNgɂ sexe.exe ̃tpX쐬
	GetModuleFileName(NULL, module_name, sizeof(module_name));
	lstrcpy(execute_path, module_name);
	extract_directory(execute_path);
#if _MSC_VER >= 1400
	_stprintf_s(ini_name, MAX_PATH, _T("%s\\%s"), execute_path, INI_FILE_NAME);
#else
	wsprintf(ini_name, _T("%s\\%s"), execute_path, INI_FILE_NAME);
#endif
	h_icon_instance = hInstance;
	language_flag = FALSE;
	h_instance = get_language_instance(hInstance, execute_path);

	// R}hC
	analyze_args(lpszArgs);

	// T[rXœ삵Ă邩H
	service_flag = check_execute_service();
	// WindowsNT/2000 ?
	if(nt_flag) {
		// T[rXƂē쒆H
		if(service_flag) {
			// łɓ쒆H
			if(!check_already()) {
				// T[rXƂċN
				start_service();
			}
		} else {
			// 2011/5/31
			// R}hCp[^ŃCXg[EACXg[
			if(install_flag) {
				TCHAR *ext;
				if(service_name[0] == _T('\0')) {
					if(!no_error_flag) {
						// T[rXw肵Ă
						MessageBoxResourceText(NULL, IDS_ERROR_NO_SERVICE_NAME, NULL, ERROR_HEADER, MB_OK);
					}
					return ERROR_PARAMETER;
				}
				ext = extract_ext(exe_name);
				if(exe_name[0] == _T('\0') || (_tcsicmp(ext, _T("exe")) && _tcsicmp(ext, _T("bat")))) {
					if(!no_error_flag) {
						// vOw肵Ă
						MessageBoxResourceText(NULL, IDS_ERROR_NO_PROGRAM_NAME, NULL, ERROR_HEADER, MB_OK);
					}
					return ERROR_PARAMETER;
				}
				if(question_flag) {
					// T[rX service_name o^܂H
					if(MessageBoxResourceText(NULL, IDS_QUESTION_INSTALL, service_name, ERROR_HEADER, MB_YESNO) != IDYES) {
						return ERROR_NO_INSTALL;
					}
				}
				if(!read_ini_flag) {
					// ini t@CǂݏôłȂΐݒlۑ
					set_inifile();
				}
				// CXg[
				if((err = install_service()) == ERROR_SUCCESS) {
					if(start_flag) {
						// T[rXJn
						if(restart_service()) {
							if(ok_flag) {
								// T[rX service_name o^AJn܂B
								MessageBoxResourceText(NULL, IDS_INSTALL_START_OK, service_name, HEADER, MB_OK);
							}
						} else if(!no_error_flag) {
							// T[rX service_name o^܂AJnɎs܂B
							MessageBoxResourceText(NULL, IDS_ERROR_INSTALL_START, service_name, HEADER, MB_OK);
							return ERROR_START;
						}
					} else if(ok_flag) {
						// T[rX service_name o^܂B
						MessageBoxResourceText(NULL, IDS_INSTALL_OK, service_name, HEADER, MB_OK);
					}
				} else {
					if(!no_error_flag) {
						if(err == ERROR_SERVICE_EXISTS) {
							// łɓ̃T[rXo^ς݂ł
							MessageBoxResourceText(NULL, IDS_ERROR_SAME_SERVICE, NULL, ERROR_HEADER, MB_OK);
						} else {
							// T[rXɓo^ł܂łB\nT[rX̌郆[U[ŃOCĎsĂB
							MessageBoxResourceText(NULL, IDS_ERROR_INSTALL_SERVICE, NULL, ERROR_HEADER, MB_OK);
						}
					}
					return ERROR_INSTALL;
				}
			} else if(uninstall_flag) {
				if(service_name[0] == _T('\0')) {
					if(!no_error_flag) {
						// T[rXw肵Ă
						MessageBoxResourceText(NULL, IDS_ERROR_NO_SERVICE_NAME, NULL, ERROR_HEADER, MB_OK);
					}
					return ERROR_PARAMETER;
				}
				if(question_flag) {
					// T[rX service_name 폜܂H
					if(MessageBoxResourceText(NULL, IDS_QUESTION_UNINSTALL, service_name, HEADER, MB_YESNO) != IDYES) {
						return ERROR_NO_INSTALL;
					}
				}
				if(service_install_flag) {
					// T[rX폜
					if(remove_service()) {
						if(ok_flag) {
							// T[rX service_name 폜܂
							MessageBoxResourceText(NULL, IDS_UNINSTALL_OK, service_name, HEADER, MB_OK);
						}
					} else {
						if(!no_error_flag) {
							// T[rX폜ł܂łB\nT[rX̌郆[U[ŃOCĎsĂB
							MessageBoxResourceText(NULL, IDS_ERROR_UNINSTALL_SERVICE, NULL, ERROR_HEADER, MB_OK);
						}
						return ERROR_INSTALL;
					}
				} else {
					if(!no_error_flag) {
						// T[rX service_name ͓o^Ă܂
						MessageBoxResourceText(NULL, IDS_ERROR_NOT_INSTALL_SERVICE, service_name, ERROR_HEADER, MB_OK);
					}
					return ERROR_INSTALL;
				}
			} else {
				// 2010/6/10 Vista/7  WM_DROPFILES 󂯂
				funcChangeWindowMessageFilter ChangeWindowMessageFilter;
				if(ChangeWindowMessageFilter = (funcChangeWindowMessageFilter)GetProcAddress(LoadLibrary(_T("user32.dll")) ,"ChangeWindowMessageFilter")) {
					ChangeWindowMessageFilter(WM_DROPFILES, MSGFLT_ADD);
					ChangeWindowMessageFilter(WM_COPYDATA, MSGFLT_ADD);
					ChangeWindowMessageFilter(0x0049, MSGFLT_ADD);
				}

				// ݒ_CAO\
				hMain = CreateDialog(h_instance, MAKEINTRESOURCE(IDD_DIALOG_SETUP), GetDesktopWindow(), (DLGPROC)MainFunc);
				ShowWindow(hMain, SW_SHOW);
				// Drag&Drop 󂯓鏀
				DragAcceptFiles(hMain, TRUE);
				while(GetMessage(&msg, NULL, 0, 0)) {
					if(!IsDialogMessage(hMain, &msg)) {
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
				}
			}
		}
	} else {
		// Windows NT/2000/XP/Vista/7 ŋNĂB
		MessageBoxResourceText(NULL, IDS_ERROR_OS, NULL, ERROR_HEADER, MB_OK);
	}
	return 0;
}

//
//	EChE񋓂ACreateProcess ŋNvZX ID 
//	Ȃ WM_CLOSE 𑗂ďIB
//
BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lParam)
{
	DWORD Pid, Tid;

	if(GetWindow(hWnd, GW_OWNER) == 0) {
		Tid = GetWindowThreadProcessId(hWnd, &Pid);
		if(Pid == process_id) {
			// 2002/6/18
			if(lParam == END_SYS_AND_CLOSE) {
				SendMessage(hWnd, WM_SYSCOMMAND, SC_CLOSE, 0);
				SendMessage(hWnd, WM_CLOSE, 0, 0);
			} else if(lParam == END_SYSCOMMAND) {
				SendMessage(hWnd, WM_SYSCOMMAND, SC_CLOSE, 0);
			} else {
				SendMessage(hWnd, WM_CLOSE, 0, 0);
			}
		}
	}
	return TRUE;
}

//
//	łɋNς݂ǂ Mutex Ŕ
//	out: TRUE .. Nς
//
BOOL check_already(void)
{
	SECURITY_DESCRIPTOR sd;
	SECURITY_ATTRIBUTES sa;
	TCHAR mutex_name[MAX_PATH];

	wsprintf(mutex_name, MUTEX_STRING, service_name);
	// rp mutex 쐬
	mutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, mutex_name);
	if(mutex != NULL) {
		if(!service_flag) {
			// łɋNĂ܂B
			MessageBoxResourceText(NULL, IDS_ERROR_ALREADY_EXECUTE, NULL, ERROR_HEADER, MB_OK);
		}
		return TRUE;
	}
	sa.lpSecurityDescriptor = NULL;
	if(InitializeSecurityDescriptor(&sd, SECURITY_DESCRIPTOR_REVISION)) {
		if(SetSecurityDescriptorDacl(&sd, TRUE, (PACL)NULL, FALSE)) {
			sa.lpSecurityDescriptor = &sd;
		}
	}
	sa.nLength = sizeof(sa);
	sa.bInheritHandle = TRUE;
	mutex = CreateMutex(&sa, FALSE, mutex_name);
	return FALSE;
}

//
//	T[rXԏXV
//
BOOL send_status_to_scm(int state, int exit_code, int progress)
{
	SERVICE_STATUS ss;

	ss.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
	ss.dwCurrentState = state;
	ss.dwControlsAccepted = SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_SHUTDOWN;
	ss.dwWin32ExitCode = exit_code;
	ss.dwServiceSpecificExitCode = 0;
	ss.dwCheckPoint = progress;
	ss.dwWaitHint = 3000;	// 3sec

	return SetServiceStatus(service_handle, &ss);
}

//
//	T[rXv
//	in: control .. SERVICE_CONTROL_STOP, SERVICE_CONTROL_SHUTDOWN ŏI
//
void service_control_handler(int control)
{
	switch(control) {
		case SERVICE_CONTROL_STOP:
		case SERVICE_CONTROL_SHUTDOWN:
			// 2009/3/26
			shutdown_flag = 1;

			send_status_to_scm(SERVICE_STOP_PENDING, 0, 1);
			if(end_pattern == END_CTRL_BREAK) {
				GenerateConsoleCtrlEvent(CTRL_BREAK_EVENT, process_id);
			} else {
				EnumWindows(EnumWindowsProc, end_pattern);
			}
			send_status_to_scm(SERVICE_STOPPED, 0, 0);
			break;
	}
}

const DWORD priority_list[] = {
	REALTIME_PRIORITY_CLASS,
	HIGH_PRIORITY_CLASS,
	ABOVE_NORMAL_PRIORITY_CLASS,
	NORMAL_PRIORITY_CLASS,
	BELOW_NORMAL_PRIORITY_CLASS,
	IDLE_PRIORITY_CLASS
};

//
//	vON
//	in: exe_name .. vOt@CpX
//	    option_name .. vOR}hCIvV
//	    pi .. vZXi[\̂̃|C^
//
BOOL execute_process(TCHAR *exe_name, TCHAR *option_name, PROCESS_INFORMATION *pi)
{
	STARTUPINFO si;
	TCHAR command[MAX_PATH], path[MAX_PATH];
	DWORD create;

	ZeroMemory(pi, sizeof(PROCESS_INFORMATION));
	GetStartupInfo(&si);
	wsprintf(command, _T("%s %s"), exe_name, option_name);
	lstrcpy(path, exe_name);
	extract_directory(path);
	create = CREATE_DEFAULT_ERROR_MODE;
	if(end_pattern == END_CTRL_BREAK) {
		AllocConsole();
		create |= CREATE_NEW_PROCESS_GROUP;
	}
	create |= priority_list[priority_flag];
	return CreateProcess(NULL, command, NULL, NULL, FALSE, create, NULL, path, &si, pi);
}

//
//	T[rXC
//
void service_main(void)
{
	PROCESS_INFORMATION pi;

	service_handle = RegisterServiceCtrlHandler(service_name,
	                               (LPHANDLER_FUNCTION)service_control_handler);
	if(service_handle != 0) {
		send_status_to_scm(SERVICE_START_PENDING, 0, 1);

		send_status_to_scm(SERVICE_RUNNING, 0, 0);
		// vONB
		if(execute_process(exe_name, option_name, &pi)) {
			// 2009/3/26
			shutdown_flag = 0;

			process_id = pi.dwProcessId;
			send_status_to_scm(SERVICE_RUNNING, 0, 0);

			// T[rX̏IŔ
			while(1) {
		    	if(WaitForSingleObject(pi.hProcess, 0) != WAIT_TIMEOUT) {
					// 2001/11/9
					CloseHandle(pi.hThread);
					CloseHandle(pi.hProcess);
					// 2009/3/26
					if(!retry_flag || shutdown_flag) {
						break;
					} else {
						if(execute_process(exe_name, option_name, &pi)) {
							process_id = pi.dwProcessId;
						} else {
							break;
						}
					}
				}
				Sleep(100);
			}
		}
		if(end_pattern == END_CTRL_BREAK) {
			FreeConsole();
		}
		CloseHandle(mutex);
	}
	send_status_to_scm(SERVICE_STOPPED, 0, 0);
}

//
//	T[rXJn
//
void start_service(void)
{
	SERVICE_TABLE_ENTRY serviceTable[] = {
		{
			service_name, (LPSERVICE_MAIN_FUNCTION)service_main
		}, {
			NULL, NULL
		}
	};
	StartServiceCtrlDispatcher(serviceTable);
}

//
//	T[rXo^
//	out: ERROR_SUCCESS .. o^
//
int install_service(void)
{
	SC_HANDLE scm, sc;
	int ret;
	DWORD stype, start;
	SERVICE_DESCRIPTION sd;

	if((scm = OpenSCManager(0, 0, SC_MANAGER_CREATE_SERVICE))) {
		stype = SERVICE_WIN32_OWN_PROCESS;
		if(desktop_flag) {
			stype |= SERVICE_INTERACTIVE_PROCESS;
		}
		if(auto_flag) {
			start = SERVICE_AUTO_START;
		} else {
			start = SERVICE_DEMAND_START;
		}
		if((sc = CreateService(scm, service_name, service_name,
		                       SERVICE_ALL_ACCESS, stype, start,
			                   SERVICE_ERROR_NORMAL,
							   module_name,
							   NULL, NULL, NULL, NULL, NULL))) {
			sd.lpDescription = description_name;
			ChangeServiceConfig2(sc, SERVICE_CONFIG_DESCRIPTION, &sd);

			CloseServiceHandle(sc);
			ret = ERROR_SUCCESS;
		} else {
			ret = GetLastError();
		}
		CloseServiceHandle(scm);
	} else {
		ret = GetLastError();
	}
	return ret;
}

//
//	T[rX폜
//	out: TRUE .. 폜
//
BOOL remove_service(void)
{
	SC_HANDLE scm, sc;
	SERVICE_STATUS st;
	BOOL ret;

	ret = FALSE;
	if((scm = OpenSCManager(0, 0, SC_MANAGER_CREATE_SERVICE))) {
		if((sc = OpenService(scm, service_name, SERVICE_ALL_ACCESS | DELETE))) {
			if(QueryServiceStatus(sc, &st)) {
				if(st.dwCurrentState != SERVICE_STOPPED) {
					if(ControlService(sc, SERVICE_CONTROL_STOP, &st)) {
						Sleep(500);
					}
				}
			}
			if(DeleteService(sc)) {
				ret = TRUE;
			}
			CloseServiceHandle(sc);
		}
		CloseServiceHandle(scm);
	}
	return ret;
}

//
//	T[rXƂċN
//	out: TRUE .. N
//
BOOL restart_service(void)
{
	SC_HANDLE scm, sc;
	BOOL ret;

	ret = FALSE;
	if((scm = OpenSCManager(0, 0, SC_MANAGER_CREATE_SERVICE))) {
		if((sc = OpenService(scm, service_name, SERVICE_ALL_ACCESS))) {
			if(StartService(sc, 0, NULL)) {
				ret = TRUE;
			}
			CloseServiceHandle(sc);
		}
		CloseServiceHandle(scm);
	}
	return ret;
}

//
//	T[rXƂċN`FbN
//	st@C̃fBNgƁAJgfBNgr
//	out: TRUE .. T[rXƂċNƎv
//
BOOL check_execute_service(void)
{
	TCHAR current_path[MAX_PATH];
	OSVERSIONINFO ovi;
	SC_HANDLE scm, sc;
	SERVICE_STATUS st;
	DWORD size;
	LPQUERY_SERVICE_CONFIG qsc;

	nt_flag = FALSE;
	service_install_flag = FALSE;
	service_stop_flag = FALSE;
	ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&ovi);
	if(ovi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		nt_flag = TRUE;
		GetCurrentDirectory(MAX_PATH, current_path);
		// st@C̃pXƃJgpXႤꍇA
		// T[rXƂċNꂽƔB
		// NhCũ[gɂ̃vOuĂA
		// CreateProcess ňႤfBNgŋNƂ܂
		// 悤ȋCB܂vł傤BB
		if(_tcsicmp(execute_path, current_path)) {
			SetCurrentDirectory(execute_path);
			return TRUE;
		}
		// T[rXCXg[`FbN
		if(scm = OpenSCManager(0, 0, SC_MANAGER_CREATE_SERVICE)) {
			if(sc = OpenService(scm, service_name, SERVICE_ALL_ACCESS)) {
				// T[rXCXg[ς
				service_install_flag = TRUE;
				// 2004/8/9
				QueryServiceConfig(sc, 0, 0, &size);
				qsc = (LPQUERY_SERVICE_CONFIG)LocalAlloc(LPTR, size);
				QueryServiceConfig(sc, qsc, size, &size);
				if(qsc->dwStartType == SERVICE_AUTO_START) {
					auto_flag = 1;
				} else if(qsc->dwStartType == SERVICE_DEMAND_START) {
					auto_flag = 0;
				}
				if(qsc->dwServiceType & SERVICE_INTERACTIVE_PROCESS) {
					desktop_flag = 1;
				} else {
					desktop_flag = 0;
				}
				LocalFree(qsc);
				if(QueryServiceStatus(sc, &st)) {
					if(st.dwCurrentState != SERVICE_STOPPED) {
						service_stop_flag = TRUE;
					}
					ControlService(sc, SERVICE_CONTROL_STOP, &st);
					Sleep(500);
				} else {
					// T[rX~ł܂B\nT[rX̌̂郆[U[ŃOCĂB
					MessageBoxResourceText(NULL, IDS_ERROR_STOP_SERVICE, NULL, ERROR_HEADER, MB_OK);
				}
				CloseServiceHandle(sc);
			}
			CloseServiceHandle(scm);
		}
	}
	return FALSE;
}

#ifdef UNICODE
//
//	fBNĝݐ؂o
//	in: path .. tpX
//
void extract_directory(TCHAR *path)
{
	TCHAR *pt;

	pt = NULL;
	while(*path != _T('\0')) {
		if(*path == _T('\\')) {
			pt = path;
		}
		path++;
	}
	if(pt != NULL) {
		*pt = _T('\0');
	}
}

//
//	t@Ĉݎo
//	in: name .. t@Ci[obt@
//	    path .. tpX
//
void extract_name_only(TCHAR *name, TCHAR *path)
{
	TCHAR *pt;

	pt = path;
	while(*path != _T('\0')) {
		if(*path == _T('\\') || *path == _T(':')) {
			pt = path + 1;
		}
		path++;
	}
	while(*pt != _T('\0') && *pt != '.') {
		*name++ = *pt++;
	}
	*name = '\0';
}
//
//	" -> \", \ -> \\ Ƃ
//	in: dst .. ϊ̕i[obt@
//	    src .. ̕obt@
//
void encode_copy(TCHAR *dst, TCHAR *src)
{
	while(*src != _T('\0')) {
		if(*src == _T('\\') || *src == _T('"')) {
			*dst++ = _T('\\');
		}
		*dst++ = *src++;
	}
	*dst = _T('\0');
}

//
//	\" -> ", \\ -> \ Ƃ
//	in: dst .. ϊ̕i[obt@
//	    src .. ̕obt@
//
void decode_copy(TCHAR *dst, TCHAR *src)
{
	while(*src != _T('\0')) {
		if(*src == _T('\\')) {
			if(*(src + 1) == _T('\\') || *(src + 1) == _T('"')) {
				src++;
			}
		}
		*dst++ = *src++;
	}
	*dst = _T('\0');
}

#else
//
//	ShiftJIS ̊Pbyteڂ`FbN
//	in: ch .. R[h
//	out: TRUE ..  1byte 
//
int iskanji(unsigned char ch)
{
    if(((ch >= 0x81) && (ch <= 0x9f))
        || ((ch >= 0xe0) && (ch <= 0xfc))){
        return TRUE;
    }
    return FALSE;
}

//
//	fBNĝݐ؂o
//	in: path .. tpX
//
void extract_directory(TCHAR *path)
{
	int flag;
	TCHAR *pt;

	pt = NULL;
	flag = FALSE;
	while(*path != '\0') {
		if(flag) {
			flag = FALSE;
		} else {
			if(iskanji((unsigned char)*path)) {
				flag = TRUE;
			} else if(*path == '\\') {
				pt = path;
			}
		}
		path++;
	}
	if(pt != NULL) {
		*pt = '\0';
	}
}

//
//	t@Ĉݎo
//	in: name .. t@Ci[obt@
//	    path .. tpX
//
void extract_name_only(TCHAR *name, TCHAR *path)
{
	int flag;
	TCHAR *pt;

	pt = path;
	flag = FALSE;
	while(*path != '\0') {
		if(flag) {
			flag = FALSE;
		} else {
			if(iskanji((unsigned char)*path)) {
				flag = TRUE;
			} else if(*path == '\\' || *path == ':') {
				pt = path + 1;
			}
		}
		path++;
	}
	while(*pt != '\0' && *pt != '.') {
		*name++ = *pt++;
	}
	*name = '\0';
}
// 2009/8/26
//
//	" -> \", \ -> \\ Ƃ
//	in: dst .. ϊ̕i[obt@
//	    src .. ̕obt@
//
void encode_copy(TCHAR *dst, TCHAR *src)
{
	int flag;

	flag = FALSE;
	while(*src != '\0') {
		if(flag) {
			flag = FALSE;
		} else {
			if(iskanji((unsigned char)*src)) {
				flag = TRUE;
			} else if(*src == '\\' || *src == '"') {
				*dst++ = '\\';
			}
		}
		*dst++ = *src++;
	}
	*dst = '\0';
}

//
//	\" -> ", \\ -> \ Ƃ
//	in: dst .. ϊ̕i[obt@
//	    src .. ̕obt@
//
void decode_copy(TCHAR *dst, TCHAR *src)
{
	int flag;

	flag = FALSE;
	while(*src != '\0') {
		if(flag) {
			flag = FALSE;
		} else {
			if(iskanji((unsigned char)*src)) {
				flag = TRUE;
			} else if(*src == '\\') {
				if(*(src + 1) == '\\' || *(src + 1) == '"') {
					src++;
				}
			}
		}
		*dst++ = *src++;
	}
	*dst = '\0';
}

#endif

//
//	gq̈ʒu擾
//	in: path .. tpX
//	out: gq̐擪ʒũ|C^
//
TCHAR *extract_ext(TCHAR *path)
{
	int len;
	TCHAR *pt;

	len = lstrlen(path);
	pt = path + len - 1;
	while(pt != path) {
		if(*pt == '.') {
			return pt + 1;
		}
		if(*pt == '\\' || *pt == '/' || *pt == ':') {
			return path + len;
		}
		pt--;
	}
	return pt;
}

//
//	.ini t@Cǂݏo
//
void get_inifile(void)
{
	TCHAR temp[MAX_PATH];

	GetPrivateProfileString(HEADER, KEY_EXE, _T(""), exe_name, MAX_PATH, ini_name);
	GetPrivateProfileString(HEADER, KEY_OPTION, _T(""), temp, MAX_PATH, ini_name);
	// 2009/8/26
	if(GetPrivateProfileInt(HEADER, KEY_ENCODE, 0, ini_name) == 0) {
		lstrcpy(option_name, temp);
	} else {
		decode_copy(option_name, temp);
	}
	GetPrivateProfileString(HEADER, KEY_NAME, _T(""), service_name, MAX_PATH, ini_name);
	GetPrivateProfileString(HEADER, KEY_DESCRIPTION, _T(""), description_name, MAX_PATH, ini_name);
	// 2002/6/19
	end_pattern = GetPrivateProfileInt(HEADER, KEY_END, END_SYS_AND_CLOSE, ini_name);
	auto_flag = GetPrivateProfileInt(HEADER, KEY_AUTO, 1, ini_name);
	desktop_flag = GetPrivateProfileInt(HEADER, KEY_DESKTOP, 0, ini_name);
	retry_flag = GetPrivateProfileInt(HEADER, KEY_RETRY, 0, ini_name);
	// 2021/5/17
	priority_flag = GetPrivateProfileInt(HEADER, KEY_PRIORITY, PRIORITY_NORMAL, ini_name);
}

//
//	l ini t@Cɏ
//	in: section .. ZNV
//	    name .. L[
//	    no .. ޒl
//	    ini_file_path .. ini t@CpX
//
void WritePrivateProfileInt(const TCHAR *section, const TCHAR *name, int no, TCHAR *ini_file_path)
{
	TCHAR temp[100];

	wsprintf(temp, _T("%d"), no);
	WritePrivateProfileString(section, name, temp, ini_file_path);
}

//
//	.ini t@Cɏ
//
void set_inifile(void)
{
	TCHAR temp[MAX_PATH];

	WritePrivateProfileString(HEADER, KEY_EXE, exe_name, ini_name);
	// 2009/8/26
	encode_copy(temp, option_name);
	WritePrivateProfileString(HEADER, KEY_OPTION, temp, ini_name);
	WritePrivateProfileString(HEADER, KEY_NAME, service_name, ini_name);
	WritePrivateProfileString(HEADER, KEY_DESCRIPTION, description_name, ini_name);
	WritePrivateProfileInt(HEADER, KEY_END, end_pattern, ini_name);
	// 2004/8/9
	WritePrivateProfileInt(HEADER, KEY_AUTO, auto_flag, ini_name);
	WritePrivateProfileInt(HEADER, KEY_DESKTOP, desktop_flag, ini_name);
	WritePrivateProfileInt(HEADER, KEY_RETRY, retry_flag, ini_name);
	// 2009/8/26
	WritePrivateProfileInt(HEADER, KEY_ENCODE, 1, ini_name);
	// 2021/5/17
	WritePrivateProfileInt(HEADER, KEY_PRIORITY, priority_flag, ini_name);
}

//
//	eXgN
//	in: exe_name .. vOt@CpX
//	    option_name .. vOR}hCIvV
//	    pattern .. Ip^[
//
void execute_program(HWND hDlg, TCHAR *exe_name, TCHAR *option_name, int pattern)
{
	PROCESS_INFORMATION pi;
	DWORD count;

	// vONB
	if(execute_process(exe_name, option_name, &pi)) {
		WaitForInputIdle(pi.hProcess,INFINITE);
		SetForegroundWindow(hDlg);
		// vON܂B\nnjNbNƃvOI܂B\nIȂꍇA蓮ŃvOIĂB\n\n sexe vOI邩ǂ̃eXgŁA\n@ۂɃT[rXł̐퓮삪ۏ؂킯ł͂܂\n@̂łӂB
		MessageBoxResourceText(hDlg, IDS_TEST_EXECUTE, NULL, HEADER, MB_OK);
		process_id = pi.dwProcessId;
		if(pattern == END_CTRL_BREAK) {
			GenerateConsoleCtrlEvent(CTRL_BREAK_EVENT, process_id);
		} else {
			EnumWindows(EnumWindowsProc, pattern);
		}
		count = GetTickCount() + 30 * 1000;
		// vOI^CAEg(30s)Ŕ
		while(count > GetTickCount()) {
	    	if(WaitForSingleObject(pi.hProcess, 0) != WAIT_TIMEOUT) {
				break;
			}
			Sleep(100);
		}
		// 2001/11/9
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
	}
	if(pattern == END_CTRL_BREAK) {
		FreeConsole();
	}
}

//
//	_CAObZ[W
//
BOOL APIENTRY MainFunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND h;
	HDROP hDrop;
	OPENFILENAME ofn;
	HICON hicon;
	TCHAR text[MAX_PATH];
	TCHAR *ext;

	switch(message) {
	case WM_INITDIALOG:
		{
			int no;

			if(_tcscmp(language_name, _T("English")) && !language_flag) {
				TCHAR title[MAX_PATH];

				GetWindowText(hDlg, text, MAX_PATH);
#if _MSC_VER >= 1400
				_stprintf_s(title, MAX_PATH, _T("%s (%s)"), text, language_name);
#else
				wsprintf(title, _T("%s (%s)"), text, language_name);
#endif
				SetWindowText(hDlg, title);
			}

			// ACRZbg
			if(hicon = LoadIcon(h_icon_instance, MAKEINTRESOURCE(IDI_ICON_SEXE))) {
				SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hicon);
				SendMessage(hDlg, WM_SETICON, ICON_BIG, (LPARAM)hicon);
			}
			// ݒlRg[ɃZbg
			h = GetDlgItem(hDlg, IDC_EDIT_EXE);
			SendMessage(h, EM_LIMITTEXT, MAX_PATH, 0);
			SetWindowText(h, exe_name);
			EnableWindow(h, !service_install_flag);

			h = GetDlgItem(hDlg, IDC_EDIT_OPTION);
			SendMessage(h, EM_LIMITTEXT, MAX_PATH, 0);
			SetWindowText(h, option_name);
			EnableWindow(h, !service_install_flag);

			h = GetDlgItem(hDlg, IDC_EDIT_NAME);
			SendMessage(h, EM_LIMITTEXT, MAX_PATH, 0);
			SetWindowText(h, service_name);
			EnableWindow(h, !service_install_flag);

			h = GetDlgItem(hDlg, IDC_EDIT_DESCRIPTION);
			SendMessage(h, EM_LIMITTEXT, MAX_PATH, 0);
			SetWindowText(h, description_name);
			EnableWindow(h, !service_install_flag);

			h = GetDlgItem(hDlg, IDC_COMBO_END);
			for(no = END_CLOSE ; no <= END_CTRL_BREAK ; no++) {
				LoadString(h_instance, IDS_ITEM_CLOSE + no, text, MAX_PATH);
				SendMessage(h, CB_ADDSTRING, 0, (DWORD)text);
			}
			SendMessage(h, CB_SETCURSEL, end_pattern, 0);
			EnableWindow(h, !service_install_flag);

			h = GetDlgItem(hDlg, IDC_COMBO_PRIORITY);
			for(no = PRIORITY_REALTIME ; no <= PRIORITY_LOW ; no++) {
				LoadString(h_instance, IDS_PRIORITY_REALTIME + no, text, MAX_PATH);
				SendMessage(h, CB_ADDSTRING, 0, (DWORD)text);
			}
			SendMessage(h, CB_SETCURSEL, priority_flag, 0);
			EnableWindow(h, !service_install_flag);

			// 2001/11/9
			h = GetDlgItem(hDlg, IDC_BUTTON_EXE);
			EnableWindow(h, !service_install_flag);

			h = GetDlgItem(hDlg, IDC_BUTTON_TEST);
			if(service_install_flag) {
				LoadString(h_instance, IDS_BUTTON_DELETE, text, MAX_PATH);
				SetWindowText(h, text);
			}

			// 2004/8/9
			h = GetDlgItem(hDlg, IDC_CHECK_AUTO);
			SendMessage(h, BM_SETCHECK, auto_flag, 0);
			EnableWindow(h, !service_install_flag);

			h = GetDlgItem(hDlg, IDC_CHECK_DESKTOP);
			SendMessage(h, BM_SETCHECK, desktop_flag, 0);
			EnableWindow(h, !service_install_flag);

			h = GetDlgItem(hDlg, IDC_CHECK_RETRY);
			SendMessage(h, BM_SETCHECK, retry_flag, 0);
			EnableWindow(h, !service_install_flag);
		}
		break;

	case WM_COMMAND:
		switch(LOWORD (wParam)) {
		case IDOK:
			// ݒl
			if(!service_install_flag) {
				h = GetDlgItem(hDlg, IDC_EDIT_NAME);
				GetWindowText(h, service_name, MAX_PATH);
				if(service_name[0] == _T('\0')) {
					// T[rXw肵Ă
					MessageBoxResourceText(hDlg, IDS_ERROR_NO_SERVICE_NAME, NULL, ERROR_HEADER, MB_OK);
					break;
				}
				h = GetDlgItem(hDlg, IDC_EDIT_EXE);
				GetWindowText(h, exe_name, MAX_PATH);
				// 2007/12/14 test
				ext = extract_ext(exe_name);
				if(exe_name[0] == _T('\0') || (_tcsicmp(ext, _T("exe")) && _tcsicmp(ext, _T("bat")))) {
					// vOw肵Ă
					MessageBoxResourceText(hDlg, IDS_ERROR_NO_PROGRAM_NAME, NULL, ERROR_HEADER, MB_OK);
					break;
				}

				h = GetDlgItem(hDlg, IDC_EDIT_OPTION);
				GetWindowText(h, option_name, MAX_PATH);

				h = GetDlgItem(hDlg, IDC_EDIT_DESCRIPTION);
				GetWindowText(h, description_name, MAX_PATH);

				h = GetDlgItem(hDlg, IDC_COMBO_END);
				end_pattern = (int)SendMessage(h, CB_GETCURSEL, 0, 0);

				// 2004/8/9
				h = GetDlgItem(hDlg, IDC_CHECK_AUTO);
				auto_flag = (int)SendMessage(h, BM_GETCHECK, 0, 0);

				h = GetDlgItem(hDlg, IDC_CHECK_DESKTOP);
				desktop_flag = (int)SendMessage(h, BM_GETCHECK, 0, 0);

				h = GetDlgItem(hDlg, IDC_CHECK_RETRY);
				retry_flag = (int)SendMessage(h, BM_GETCHECK, 0, 0);

				h = GetDlgItem(hDlg, IDC_COMBO_PRIORITY);
				priority_flag = (int)SendMessage(h, CB_GETCURSEL, 0, 0);

				// ݒlۑ
				set_inifile();

				// T[rX %s o^܂H
				if(MessageBoxResourceText(hDlg, IDS_QUESTION_INSTALL, service_name, HEADER, MB_YESNO) == IDYES) {
					int err;
					if((err = install_service()) == ERROR_SUCCESS) {
						// 2001/11/9
						// T[rX %s o^܂BT[rXƂċN܂H
						if(MessageBoxResourceText(hDlg, IDS_QUESTION_INSTALL_START, service_name, HEADER, MB_YESNO) == IDYES) {
							restart_service();
						}
					} else {
						if(err == ERROR_SERVICE_EXISTS) {
							// łɓ̃T[rXo^ς݂ł
							MessageBoxResourceText(NULL, IDS_ERROR_SAME_SERVICE, NULL, ERROR_HEADER, MB_OK);
						} else {
							// T[rXɓo^ł܂łB\nT[rX̌郆[U[ŃOCĎsĂB
							MessageBoxResourceText(hDlg, IDS_ERROR_INSTALL_SERVICE, NULL, HEADER, MB_OK);
						}
					}
				}
			}
			DestroyWindow(hDlg);
			break;

		case IDCANCEL:
			DestroyWindow(hDlg);
			break;

		case IDC_BUTTON_EXE:
			{
				TCHAR filter[MAX_PATH];
				TCHAR title[MAX_PATH];
				int len;
				// Qƃ{^ꂽ
				text[0] = '\0';
				FillMemory(&ofn, sizeof(OPENFILENAME), 0);
				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = hDlg;
				ofn.nMaxFile = MAX_PATH;
				ofn.lpstrFile = text;
				// st@C(*.exe)\0*.exe\0"
				LoadString(h_instance, IDS_FILE_EXE, filter, MAX_PATH);
				len = lstrlen(filter);
				LoadString(h_instance, IDS_FILE_WILD_EXE, filter + len + 1, MAX_PATH - len - 2);
				len += lstrlen(filter + len + 1);
				*(filter + len + 2) = '\0';
				ofn.lpstrFilter = filter;
				// st@C̑I
				LoadString(h_instance, IDS_FILE_TITLE, title, MAX_PATH);
				ofn.lpstrTitle = title;
				ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;
				if(GetOpenFileName(&ofn)) {
					ext = extract_ext(text);
					if(!_tcsicmp(ext, _T("exe")) || !_tcsicmp(ext, _T("bat"))) {
						TCHAR name[MAX_PATH];
						// .exe t@CZbg
						h = GetDlgItem(hDlg, IDC_EDIT_EXE);
						SetWindowText(h, (LPCTSTR)text);
						// T[rXƂ .exe t@C̖OZbg
						extract_name_only(name, text);
						h = GetDlgItem(hDlg, IDC_EDIT_NAME);
						SetWindowText(h, (LPCTSTR)name);
					} else {
						// vOt@Ĉݓo^\łB
						MessageBoxResourceText(hDlg, IDS_ERROR_NOT_PROGRAM, NULL, ERROR_HEADER, MB_OK);
					}
				}
			}
			break;

		case IDC_BUTTON_TEST:
			// T[rXƂăCXg[ς݁H
			if(service_install_flag) {
				// T[rX service_name 폜܂H
				if(MessageBoxResourceText(hDlg, IDS_QUESTION_UNINSTALL, service_name, HEADER, MB_YESNO) == IDYES) {
					// T[rX폜
					if(remove_service()) {
						// T[rX service_name 폜܂
						MessageBoxResourceText(hDlg, IDS_UNINSTALL_OK, service_name, HEADER, MB_OK);

						service_install_flag = FALSE;
						h = GetDlgItem(hDlg, IDC_EDIT_EXE);
						EnableWindow(h, TRUE);

						h = GetDlgItem(hDlg, IDC_EDIT_OPTION);
						EnableWindow(h, TRUE);

						h = GetDlgItem(hDlg, IDC_EDIT_NAME);
						EnableWindow(h, TRUE);

						h = GetDlgItem(hDlg, IDC_EDIT_DESCRIPTION);
						EnableWindow(h, TRUE);

						h = GetDlgItem(hDlg, IDC_COMBO_END);
						EnableWindow(h, TRUE);

						// 2021/5/17
						h = GetDlgItem(hDlg, IDC_COMBO_PRIORITY);
						EnableWindow(h, TRUE);

						// 2001/11/9
						h = GetDlgItem(hDlg, IDC_BUTTON_EXE);
						EnableWindow(h, TRUE);

						h = GetDlgItem(hDlg, IDC_BUTTON_TEST);
						// eXgN(&T)
						LoadString(h_instance, IDS_BUTTON_TEST, text, MAX_PATH);
						SetWindowText(h, text);

						// 2004/8/9
						h = GetDlgItem(hDlg, IDC_CHECK_AUTO);
						EnableWindow(h, TRUE);

						h = GetDlgItem(hDlg, IDC_CHECK_DESKTOP);
						EnableWindow(h, TRUE);

						h = GetDlgItem(hDlg, IDC_CHECK_RETRY);
						EnableWindow(h, TRUE);
					} else {
						// T[rX폜ł܂łB\nT[rX̌郆[U[ŃOCĎsĂB
						MessageBoxResourceText(NULL, IDS_ERROR_UNINSTALL_SERVICE, NULL, ERROR_HEADER, MB_OK);
					}
				}
			} else {
				TCHAR param[MAX_PATH];

				// eXgN
				h = GetDlgItem(hDlg, IDC_EDIT_EXE);
				GetWindowText(h, text, MAX_PATH);

				h = GetDlgItem(hDlg, IDC_EDIT_OPTION);
				GetWindowText(h, param, MAX_PATH);

				h = GetDlgItem(hDlg, IDC_COMBO_END);
				execute_program(hDlg, text, param, (int)SendMessage(h, CB_GETCURSEL, 0, 0));
			}
			break;
		}
		break;

	case WM_DROPFILES:
		// Drag&Drop Ŏ󂯂t@Co
		hDrop = (HDROP)wParam;
		DragQueryFile(hDrop, 0, text, MAX_PATH);
		DragFinish(hDrop);
		if(!service_install_flag) {
			if(!_tcsicmp(extract_ext(text), _T("exe"))) {
				TCHAR name[MAX_PATH];
				// .exe t@CZbg
				h = GetDlgItem(hDlg, IDC_EDIT_EXE);
				SetWindowText(h, text);
				// T[rXƂ .exe t@C̖OZbg
				extract_name_only(name, text);
				h = GetDlgItem(hDlg, IDC_EDIT_NAME);
				SetWindowText(h, (LPCTSTR)name);
			} else {
				// vOt@Ĉݓo^\łB
				MessageBoxResourceText(hDlg, IDS_ERROR_NOT_PROGRAM, NULL, ERROR_HEADER, MB_OK);
			}
		}
		SetForegroundWindow(hDlg);
		break;

	case WM_HELP:
		ShellExecute(hDlg, _T("open"), _T("sexe.chm"), NULL, NULL, SW_SHOW);
		break;

	case WM_DESTROY:
		// 2001/11/9
		if(service_stop_flag) {
			restart_service();
		}
		PostQuitMessage(0);
		break;

	default:
		return FALSE;
	}
	return FALSE;
}

